'HotBasic HotXLS.inc  Copyright 2002-2005 James J Keene PhD
'Last Modified: June 18, 2005

'These functions read all sheets in Excel .xls files.
$TYPECHECK ON
$RESOURCE xls_dat AS "HotXLS.dat"

'R value masks
$DEFINE xRKby100 &H1   '0=value not changed
$DEFINE xRKInteger &H2 '0=floating-point
$DEFINE xRKEncoded &HFFFFFFFC

'Error Codes
'$DEFINE xNULL 0
'$DEFINE xDIVby0 &H7
'$DEFINE xVALUE &HF
'$DEFINE xRK &H17
'$DEFINE xNAME &H1D
'$DEFINE xNUM &H24
'$DEFINE xNA &H2A

$OPTION DIM WORD 
'Record Codes-WorkBook
CONST xBOF=&H809
CONST xEOF=&HA
CONST xFILEPASS=&H2F
CONST xPASSWORD=&H13
CONST xBOUNDSHEET=&H85
CONST xSST=&HFC
CONST xCONTINUE=&H3C
'Record Codes-WorkSheets
CONST xINDEX=&H20B
CONST xDIMENSIONS=&H200
CONST xROW=&H208
CONST xDBCELL=&HD7
CONST xWINDOW2=&H23E
CONST xSELECTION=&H1D
'Record Codes-Cells
CONST xARRAY=&H221
CONST xBLANK=&H201
CONST xBOOLERR=&H205
CONST xFORMULA=&H206
CONST xLABEL=&H204
CONST xLABELSST=&HFD
CONST xNUMBER=&H203
CONST xMULBLANK=&HBE
CONST xMULRK=&HBD
CONST xRK=&H27E
CONST xRSTRING=&HD6
CONST xSHRFMLA=&HBC
CONST xSTRING=&H207

defdbl lowdbl = val("-1.5E-45")
defdbl hidbl = val("3.4E+38")

'P table columns
$DEFINE pOFFSET 0
$DEFINE pSHEET 1
$DEFINE pDIMENSIONS 2
$DEFINE pminROW 3
$DEFINE pmaxROW 4
$DEFINE pminCOL 5
$DEFINE pmaxCOL 6
$DEFINE pLENGTH 7
$DEFINE NumVars 7

'Program 0-based dimension constants
$DEFINE MaxSheets 31  
$DEFINE MaxBytes 4095
$DEFINE MaxSST 255
$DEFINE fmCreate 65535

Declare FUNCTION xlsOPEN As LONG
Declare FUNCTION xlsSAVE(file As STRING) As LONG
Declare FUNCTION xlsREAD(s As LONG, row As LONG, col As LONG) As STRING
Declare FUNCTION xlsWRITE(s As LONG, row As LONG, col As LONG, value As STRING) As LONG
Declare FUNCTION xlsSHEETNAME(s As LONG) As STRING
Declare FUNCTION xlsMINROW(s As LONG) As LONG
Declare FUNCTION xlsMAXROW(s As LONG) As LONG
Declare FUNCTION xlsMINCOL(s As LONG) As LONG
Declare FUNCTION xlsMAXCOL(s As LONG) As LONG
Declare FUNCTION xlsSHEETLENGTH(s As LONG) As LONG
Declare FUNCTION xlsNUMBERSHEETS As LONG
Declare FUNCTION xlsCLOSE As LONG

Declare FUNCTION B2W(index As LONG) As WORD
Declare FUNCTION RK2str As STRING
Declare FUNCTION StrRecLen As LONG

Declare SUB ReadOLEFile
Declare SUB GetRecord
Declare SUB GetData
Declare SUB ClearBookData
Declare SUB ShiftBook(ptr As LONG, nbytes As LONG)
Declare SUB SheetPointers(s As LONG, nbytes As LONG)
Declare SUB ChangeValue(ptr As LONG, blen As LONG, nbytes As LONG)
Declare SUB FillFile(fvalue As LONG, amt As LONG)
Declare SUB PrintSheetNames
Declare SUB PrintSSTRecords

'Stratch variables
Dim xB1 As BYTE, xB2 As BYTE
DIM buf(MaxBytes) As Byte
DIM xCode As WORD, xLength As WORD, sCode As WORD, sLength As WORD, xFinish As WORD
DIM xType As LONG, xFormat As WORD, xIntegrity As WORD
DIM i As LONG, j As LONG, k As LONG, n As LONG, xEnd As LONG, xTmp As LONG
DIM xPosition As LONG, xNext As Long, wPosition As LONG 
DIM ptrINDEX As LONG, ptrINDEXEnd As LONG
DIM ptrDB As LONG, ptrDBOffset As LONG, ptrROW As LONG, ptrData As LONG
DIM RK As LONG, xInt As LONG, xUnicode As LONG
DIM xIEEE As DOUBLE 
DIM s$ As STRING, sERR As STRING
DIM F As File, F2 As File
'WorkBook specific
DIM M As Memory
DIM FileSpec As STRING
DIM P(MaxSheets,NumVars) As LONG
DIM SST(s,MaxSST,2) As LONG  'unique string block data
DIM tSST As LONG    'n unique strings
DIM nSST As WORD    'n blocks of strings in SST 
DIM nSheets As WORD 'n sheets according to BOUNDSHEET records
DIM nSR As WORD     'n sheets read
DIM SheetName(MaxSheets) As STRING
  
'''''Main Routines
FUNCTION xlsOPEN
Result=-1: xFinish=0: sERR=""
ClearBookData
IF NOT FILEEXISTS(FileSpec) THEN sERR="File not found": Exit Function
ReadOLEFile
IF sERR.length THEN Goto OpenFail
M.Position=0
FindBOF:
GetRecord
IF xCode=xBOF THEN
  xNext=M.Position-4
  IF xNext>0 THEN Call ShiftBook(0,-xNext): xNext=0
  P(0,0)=0: Goto NextParse
ELSE
  M.Position=M.Position+&H3C
  IF M.Position<M.Size THEN Goto FindBOF   
  sERR="BOF not found": Goto OpenFail
END IF
NextOpen:
xPosition=M.Position: GetRecord
SELECT CASE xCode
CASE xBOF
  GetData
  IF B2W(0)<>&H600 THEN sERR="Not BIFF8 file": Goto OpenFail
  IF B2W(2)<>5 THEN
    IF nSR<MaxSheets THEN INC(nSR) ELSE sERR="Too many sheets": Goto OpenFail
    IF xPosition<>P(nSR,0) THEN sERR="File format read error": Goto OpenFail
  END IF
  P(nSR,pOFFSET)=xPosition
CASE xEOF
  P(nSR,pLENGTH)=M.Position-P(nSR,pOFFSET)
  IF nSR=nSheets THEN xFinish=1 'accounted for all BOUNDSHEETs
' WorkBook Globals
CASE xFILEPASS
  IF xLength THEN sERR="File password required": Goto OpenFail
CASE xPASSWORD
  IF xLength<>2 THEN sERR="Password required": Goto OpenFail
CASE xBOUNDSHEET
  IF nSheets<MaxSheets THEN INC(nSheets) ELSE sERR="Too many sheets": Goto OpenFail
  P(nSheets,pSHEET)=xPosition: GetData
  MEMCPY(VARPTR(i),VARPTR(buf),4): P(nSheets,pOFFSET)=i
  k=buf(6) + 256 * buf(7) + 7: s$=""
  FOR i=8 to k: s$=s$+CHR$(buf(i)): NEXT i
  SheetName(nSheets)=s$
CASE xSST
  IF SST(0,0)<>0 THEN sERR="Multiple SST records": Goto OpenFail
  SST(0,0)=xPosition+12
  M.Position=M.Position+4: tSST=M.ReadNum(4) 'Total SST strings
  nSST=0: j=0: k=0
  IF tSST=0 THEN Goto CheckSSTTotal
  CountStrings:
'  xTmp=StrRecLen
   sLength=M.ReadNum(2): xTmp=sLength
   sCode=0: sCode=M.ReadNum(1)
   IF sCode AND 1 THEN sLength=2*sLength: xTmp=sLength 'String not compressed
   IF sCode AND 8 THEN xTmp=M.ReadNum(2): xTmp=sLength+4*xTmp 'RichString
   IF sCode AND 4 THEN i=M.ReadNum(4): xTmp=xTmp+i  'Far East
'
  M.Position=M.Position+xTmp: INC(k)
  IF j+k>=tSST THEN Goto EndofBlock
  IF M.Position<xNext THEN Goto CountStrings
  EndofBlock:
  xTmp=0
  'Check if some lamer wrote a string across records.  Thus...
  IF M.Position>xNext THEN xTmp=one+M.Position-xNext
  SST(nSST,1)=k: SST(nSST,2)=M.Position: j=j+k: k=0
  IF j>=tSST THEN Goto CheckSSTTotal
  IF M.Position>P(1,0) THEN Goto CheckSSTTotal
  M.Position=xNext: GetRecord
  IF xCode=xCONTINUE THEN 
    IF nSST=MaxSST THEN sERR="MaxSST too small": Goto OpenFail
    INC(nSST): M.Position=M.Position+xTmp  'ptr to 1st in record
    SST(nSST,0)=M.Position: Goto CountStrings
  END IF
  CheckSSTTotal:
  IF j<>tSST THEN sERR="SST total mismatch "+STR$(j)+" "+STR$(tSST)+" at "+HEX$(M.Position): Goto OpenFail
  IF xIntegrity=0 THEN xNext=P(1,pOFFSET)-4 '->next EOF
' WorkSheet Data  
CASE xDIMENSIONS
  P(nSR,pDIMENSIONS)=xPosition
  P(nSR,pminROW)=M.ReadNum(4): P(nSR,pmaxROW)=M.ReadNum(4)
  P(nSR,pminCOL)=M.ReadNum(2): P(nSR,pmaxCOL)=M.ReadNum(2)
  IF xIntegrity=1 THEN Goto NextParse
  IF nSR<nSheets THEN xNext=P(nSR+1,pOFFSET)-4: Goto NextParse 'Next BOF-4
  i=P(0,pSHEET)
  IF i>4096 AND i>M.Position THEN xNext=P(0,pSHEET)-4  'BIFF8 length-4
END SELECT
NextParse:
M.Position=xNext
IF xFinish=1 Then Goto OpenDone 
IF M.Position<M.Size-4 Then Goto NextOpen
sERR="Unexpected end of file"
OpenFail:
'ClearBookData
M.Close: Exit Function
OpenDone:
Result=nSR
END FUNCTION

FUNCTION xlsSAVE(file As STRING) As LONG
DIM FAT(4) As LONG
Result=&HFFFFFFFF  '-1
sERR=""
IF FILEEXISTS(file) THEN KILL file
F.Open(file,fmCreate)
IF NOT FILEEXISTS("hotxls.dat") THEN ExtractResource("xls_dat","hotxls.dat")
'DoEvents
F2.Open("hotxls.dat",0)
M.Position=0: F.Position=0: F.CopyFrom(F2,80): FillFile(&HFFFFFFFF,&H200) 'OLE header
FAT(0)=P(0,pSHEET)  'file length
F.CopyFrom(M,FAT(0))
IF FAT(0)>&H1000 THEN i=&H200 ELSE i=&H1000  
FillFile(0,i)
FAT(1)=F.Position: i=1: xPosition=(F.Position-&H200)\&H200 'ptr to FAT
WriteFATentry:
IF i<xPosition THEN F.WriteNum(i,4): INC(i): Goto WriteFATentry
n=&HFFFFFFFE: F.WriteNum(n,4)
j=(F.Position-FAT(1))\&H200+one '# of FAT sectors
j=j+(j+2)\128
For i=1 to j: n=&HFFFFFFFD: F.WriteNum(n,4): NEXT i
CheckFATCount:
k=(F.Position-FAT(1))\&H200+one
IF k>j THEN n=&HFFFFFFFD: F.WriteNum(n,4): xTmp=F.Position
n=&HFFFFFFFE: F.WriteNum(n,4): FillFile(&HFFFFFFFF,&H200)
FAT(4)=(F.Position-FAT(1))\&H200  'final update of # FAT sectors
IF FAT(4)>k THEN F.Position=xTmp: j=k-1: Goto CheckFATCount
xInt=(F.Position-&H200)\&H200     'ptr to DIR
xTmp=F.Position: F2.Position=&H50
F.CopyFrom(F2,512) 'ole directory
IF FAT(0)<&H1000 THEN i=&H1000 ELSE i=FAT(0)
F.Position=xTmp+&HF8: F.WriteNum(i,4) 'length
F.Position=&H2C: n=FAT(4): F.WriteNum(n,4) 'put # of FAT sectors
F.Position=&H30: F.WriteNum(xInt,4)   'put DIR ptr
F.Position=&H4C: i=xPosition: xNext=&H200
WriteFATindex:
F.WriteNum(i,4): INC(i)
IF F.Position<>xNext THEN Goto FATindexDone
IF F.Position=&H200 THEN
  F.Position=&H44: n=xInt+1: F.WriteNum(n,4)
  F.Position=(xInt+2)*&H200: xNext=F.Position+&H1FC 
ELSE
  j=(F.Position+4)\&H200-1: F.WriteNum(j,4): xNext=F.Position+&H1FC
END IF
FATindexDone:
IF i<xInt THEN Goto WriteFATindex
FillFile(&HFFFFFFFF,&H200)  
IF FAT(4)>109 THEN i=(FAT(4)-109)\128+1: F.Position=&H48: F.WriteNum(i,4)
Result=F.Size
F.Close: F2.Close
END FUNCTION

FUNCTION xlsREAD(s As LONG, row As LONG, col As LONG) As STRING
DIM r As WORD, cc As WORD, strindex As WORD
Result="": sERR=""
IF s>nSR THEN sERR="Sheet index too big": Exit Function
IF row<P(s,pminROW) OR row>=P(s,pmaxROW) THEN sERR="Row out of bounds": Exit Function
IF col<0 OR col>255 THEN sERR="Col out of bounds": Exit Function
M.Position=P(s,pOFFSET)+20     'index record
xEnd=P(s,pOFFSET)+P(s,pLENGTH)  'end of sheet
'Find row block
GetIndexRecord:
GetRecord
ptrINDEXEnd=xNext
IF xCode=xINDEX THEN Goto CheckIndex
M.Position=xNext
IF xNext<xEnd THEN Goto GetIndexRecord ELSE sERR="Index not found": Exit Function '&H208
CheckIndex:
i=M.Readnum(4)
IF i THEN sERR="Bad Index record format": Exit Function
i=M.Readnum(4)
IF i<>P(s,pminROW) THEN sERR="Index and Dimensions disagree": Exit Function
j=M.Readnum(4)
IF j<>P(s,pmaxROW) THEN sERR="Index and Dimensions disagree": Exit Function
n=row-i: j=4 * (n\32) + 4
IF j+12>xLength THEN sERR="Index record too short": Exit Function
ptrINDEX=M.Position+j: M.Position=ptrINDEX: i=M.ReadNum(4)
IF i<0 THEN sERR="Neg index pointer": Exit Function
IF i>xEnd THEN sERR="Bad index pointer": Exit Function
M.Position=i: xEnd=i
GetRecord
IF xCode<>xDBCELL THEN sERR="DBCell not found": Exit Function
ptrDBOffset=M.Position: xTmp=xNext: GetData
MEMCPY(VARPTR(i),VARPTR(buf),4) 'neg offset to first cell data record
j=(xEnd-i)+20: k=0: i=0: M.Position=j-20
GetRowRecord:
ptrROW=M.Position
GetRecord
IF xCode<>xROW THEN sERR="Row record not found": Exit Function
k=k+buf(2*i+4)+256 * buf(2*i+5): r=M.ReadNum(4)
IF r<row THEN M.Position=xNext: INC(i): Goto GetRowRecord
ptrDB=xEnd+10+2*i
IF ptrDB>=xTmp THEN ptrDB=0
IF r>row THEN sERR="Row not defined": Exit Function
i=j+k: M.Position=i: xPosition=i
IF i<ptrROW OR i>xEnd THEN sERR="No cell record": Exit Function
NextRead:
xPosition=M.Position
GetRecord
SELECT CASE xCode
  CASE xSTRING, xARRAY, xSHRFMLA, &H4BC, xCONTINUE
  Goto KeepMoving
END SELECT
GetData: r=buf(0)+256*buf(1)
IF r<>row THEN sERR="Col not found/defined": Exit Function
cc=buf(2)+256*buf(3)
IF cc>col THEN Exit Function  'columns to left were blank/not defined
IF cc<col AND xCode<>xMULRK THEN Goto KeepMoving
xFormat=buf(4)+256*buf(5): wPosition=xPosition
CellType:
SELECT CASE xCode
CASE xLABELSST
  strindex=buf(6)+256*buf(7): k=0: i=0
  FindSSTRecord:
  j=k: k=k+SST(i,1)
  IF strindex<k THEN Goto FindString
  IF i<nSST THEN INC(i): Goto FindSSTRecord
  sERR="Index>no. strings": Exit Function
  FindString:
  M.Position=SST(i,0): xNext=SST(i,2)
  SSTString:
'  xTmp=StrRecLen
   sLength=M.ReadNum(2): xTmp=sLength
   sCode=0: sCode=M.ReadNum(1)
   IF sCode AND 1 THEN sLength=2*sLength: xTmp=sLength 'String not compressed
   IF sCode AND 8 THEN xTmp=M.ReadNum(2): xTmp=sLength+4*xTmp 'RichString
   IF sCode AND 4 THEN i=M.ReadNum(4): xTmp=xTmp+i  'Far East
'
  IF j<>strindex THEN Goto NextSSTEntry
  GetUnicodeNow:
  xUnicode=M.Position+M.Pointer: s$=""
  FOR i=1 TO sLength STEP 1
  'Check if string written across a CONTINUE record
  IF M.Position=xNext THEN M.Position=M.Position+5
  xB1=M.ReadNum(1)
  'for 16-bit char and NOT (Far East OR Rich Text), get odd bytes only 
  IF sCode=1 THEN
    xB2=M.ReadNum(1): INC(i)
    SELECT CASE xB2
    CASE 4 'RUSSIAN
    IF xB1=1 THEN j=167 ELSE j=176
    IF xB1=81 THEN j=103
    xB1=xB1+j
    END SELECT
  END IF
  s$.write(xB1)  's$=s$+CHR$(xB1)
  NEXT i
  Result=s$: xType=&HFFFFFFFF: Exit Function
  NextSSTEntry:
  INC(j): M.Position=M.Position+xTmp
  IF M.Position>P(1,pOFFSET) THEN sERR="SST read error": Exit Function
  Goto SSTString
CASE xRK, &H7E
  MEMCPY(VARPTR(RK),VARPTR(buf)+6,4)
  Result=RK2str: Exit Function
CASE xNUMBER
  xIEEEnumber:
  MEMCPY(VARPTR(xIEEE),VARPTR(buf)+6,8)
  Result=STR$(xIEEE): xType=4: Exit Function
CASE xMULRK
  IF cc>col THEN Goto KeepMoving
  i=6  'first RK in buf
  NextMULRK:
  IF cc<col AND i+6<xLength THEN INC(cc): i=i+6: Goto NextMULRK
  IF cc=col THEN
    MEMCPY(VARPTR(RK),VARPTR(buf)+i,4): ptrData=xPosition+i+4
    Result=RK2str: Exit Function
  END IF
CASE xBLANK
  sERR="#BLANK": Exit Function
CASE xLABEL
  M.Position=xPosition+10: xTmp=StrRecLen: Goto GetUnicodeNow
CASE xBOOLERR
  sERR="#BOOLERR": Exit Function
CASE xFORMULA, &H6, &H406
  xTmp=buf(12)+256*buf(13): sERR="#FORMULA"
  IF buf(6)=0 AND xTmp=&HFFFF THEN 
    M.Position=xNext  'Return value in next record
    GetRecord
    GetData
    SELECT CASE xCode
      CASE xARRAY, xSHRFMLA, &H4BC
      M.Position=xNext: GetRecord
      GetData: Goto CellType
    END SELECT
    Goto CellType
  END IF
  IF buf(6)=1 AND xTmp=&HFFFF THEN Result=STR$(buf(8)): xType=2: Exit Function
  Goto xIEEEnumber 
CASE xMULBLANK
CASE xSTRING
  sLength=buf(0)+256*buf(1): s$=""
  FOR i=1 to sLength: s$=s$+CHR$(buf(i+2)): NEXT i
  Result=s$: xType=&HFFFFFFFF: Exit Function
CASE xWINDOW2: Exit Function
CASE xSELECTION: Exit Function
CASE xDBCELL: sERR="Cell not found": Exit Function
CASE xRSTRING: sERR="#RSTRING obsolete in BIFF8": Exit Function
CASE ELSE
  sERR="#"+RIGHT$(HEX$(xCode),4)+" unexpected record code": Exit Function
END SELECT
KeepMoving:
M.Position=xNext
IF M.Position<=xEnd-4 THEN Goto NextRead
END FUNCTION

FUNCTION xlsWRITE(s As LONG, row As LONG, col As LONG, value As STRING) As LONG
DIM wr As LONG, wc As LONG, ws As LONG, wInt As LONG
DIM wType As LONG, wLength AS WORD
DIM xSingle As SINGLE
DIM r$ As STRING
Result=-1: sERR=""
IF row>P(s,pmaxROW) THEN sERR="Row not found": Exit Function
wr=row: wc=col: ws=s: wType=-1: wLength=value.Length
IF wLength=0 THEN wType=-2: Goto MakeRecord  'null string->BLANK
FOR i=1 to wLength: s$=value[i]
IF s$>"9" OR s$<"-" OR s$="\" THEN Goto MakeRecord
NEXT i
s$=value: i=TALLY(s$,".")
IF i>1 THEN Goto MakeRecord
j=TALLY(s$,"-")
IF j>1 then Goto MakeRecord
IF j>0 AND s$[1]<>"-" THEN Goto MakeRecord '"-" not first char
wType=4: xIEEE=VAL(s$)
IF (wLength-i-j)>6 THEN Goto MakeRecord
IF xIEEE>536870911.0 OR xIEEE<-536870912.0 THEN Goto NotInteger
IF i=0 THEN wInt=xIEEE: wType=2: Goto MakeRecord
IF INSTR(1,s$,".")<wLength-2 THEN Goto NotInteger
IF xIEEE>5368709.11 OR xIEEE<-5368709.12 THEN Goto NotInteger
wInt=xIEEE*100.0: wType=3: Goto MakeRecord 'x 100

NotInteger:
IF xIEEE<lowdbl OR xIEEE>hidbl THEN Goto MakeRecord
xSingle=xIEEE
IF (xSingle AND &HC0000000)=0 THEN wType=0 

MakeRecord:
'Check if record already there
ptrINDEXEnd=0: ptrINDEX=0: ptrDBOffset=0: ptrROW=0: ptrDB=0: ptrData=0: wPosition=0
r$=xlsREAD(ws, wr, wc)  'if record exists, xPosition to xNext-1 is field
IF r$="" AND sERR[1]<>"#" THEN xLength=0 ELSE INC(xLength,4)
MEMSET(VARPTR(buf),0,4)
buf(4)=wr MOD 256: buf(5)=wr\256: buf(6)=wc MOD 256: buf(7)=wc\256
IF NOT xFormat THEN xFormat=&HF
buf(8)=xFormat MOD 256: buf(9)=xFormat\256
'print "wType="; wType
SELECT CASE wType
  CASE &HFFFFFFFE: buf(0)=1: buf(1)=2: buf(2)=6
  CASE &HFFFFFFFF: buf(0)=4: buf(1)=2
    buf(10)=wLength MOD 256: buf(11)=wLength\256: buf(12)=0
    buf(2)=(9+wLength) MOD 256: buf(3)=(9+wLength)\256
    FOR i=1 to wLength: buf(12+i)=ASC(value[i]): NEXT i
  CASE <4: buf(0)=xRK: buf(1)=2: buf(2)=10
    IF wType=1 THEN xSingle=100.0*xSingle
    IF wType AND 2 THEN RK=wInt SHL 2 ELSE MEMCPY(VARPTR(RK),VARPTR(xIEEE)+4,4)   
    RK=(RK AND xRKEncoded) OR wType
    MEMCPY(VARPTR(buf)+10,VARPTR(RK),4) 
  CASE 4: buf(0)=xNUMBER: buf(1)=2: buf(2)=14: MEMCPY(VARPTR(buf)+10,VARPTR(xIEEE),8) 
END SELECT
wLength=4+buf(2)+256*buf(3)
wInt=wLength-xLength
IF wInt=0 THEN Goto xPutNew
IF xCode=xMULRK THEN M.Position=ptrData: M.WriteNum(RK,4): Goto xWriteDone
SELECT CASE sERR
  CASE "Row not defined": Exit Function
  CASE "Col out of bounds": Exit Function
  CASE ELSE: wPosition=xPosition
END SELECT

'Update column data
IF wc<P(ws,pminCOL) THEN
  P(ws,pminCOL)=wc: xTmp=P(ws,pDIMENSIONS)+12
  M.Position=xTmp: M.WriteNum(wc,2)
END IF
IF wc>P(ws,pmaxCOL)-1 THEN
  i=wc+1: P(ws,pmaxCOL)=i: xTmp=P(ws,pDIMENSIONS)+14
  M.Position=xTmp: M.WriteNum(i,2)
END IF
IF ptrROW=0 THEN Goto FileLength
M.Position=ptrROW+6: sCode=M.ReadNum(2)
IF wc<sCode THEN M.Position=ptrROW+6: M.WriteNum(wc,2)
M.Position=ptrROW+8: sCode=M.ReadNum(2)
IF wc>=sCode THEN M.Position=ptrROW+8: i=wc+1: M.WriteNum(i,2)

FileLength:
ChangeValue(P(ws,pOFFSET)+36,4,wInt) 'change ptr needed by Excel
UpdateINDEX:
ChangeValue(ptrINDEX,4,wInt): INC(ptrINDEX,4)
IF ptrINDEX<ptrINDEXEnd THEN Goto UpdateINDEX
SheetPointers(ws,wInt)
ChangeValue(ptrDBOffset,4,wInt)
IF ptrDB>0 THEN ChangeValue(ptrDB,2,wInt)

IF wInt>0 THEN
  ShiftBook(wPosition,wInt)
  i=P(nSR,pOFFSET)+P(nSR,pLENGTH): INC(i,wInt)
  IF i>P(0,pSHEET) THEN P(0,pSHEET)=i
ELSE
  ShiftBook(wPosition+wLength,wInt)
END IF

xPutNew:
MEMCPY(wPosition+M.Pointer,VARPTR(buf),wLength)
xWriteDone:
IF wLength>0 THEN sERR=""
Result=wLength
END FUNCTION

FUNCTION xlsSHEETNAME(s As LONG) As STRING
Result=SheetName(s) 
END FUNCTION

FUNCTION xlsMINROW(s As LONG) As LONG
Result=P(s,pminROW)
END FUNCTION

FUNCTION xlsMAXROW(s As LONG) As LONG
Result=P(s,pmaxROW)-1
END FUNCTION

FUNCTION xlsMINCOL(s As LONG) As LONG
Result=P(s,pminCOL)
END FUNCTION

FUNCTION xlsMAXCOL(s As LONG) As LONG
Result=P(s,pmaxCOL)-1
END FUNCTION

FUNCTION xlsSHEETLENGTH(s As LONG) As LONG
Result=P(s,pLENGTH)
END FUNCTION

FUNCTION xlsNUMBERSHEETS
Result=nSR
END FUNCTION

FUNCTION xlsCLOSE
M.Close: ClearBookData: Result=0
END FUNCTION

'''''Supporting routines
SUB GetRecord
xCode=M.ReadNum(2): xLength=M.ReadNum(2): xNext=M.Position+xLength
END SUB

SUB GetData
Dim kmax As WORD
IF NOT xLength THEN Exit SUB
kmax=MaxBytes
IF kmax>xLength-1 THEN kmax=xLength-1
FOR i=0 to kmax: buf(i)=M.ReadNum(1): Next i
END SUB

FUNCTION RK2str
xType=RK AND 3
IF RK AND xRKInteger THEN   
  ASM mov eax,RK:ASM shr eax,2: ASM mov xInt,eax
  IF RK<0 THEN xInt=xInt OR &HC0000000
  s$=STR$(xInt)
  IF RK AND xRKby100 THEN
    RK2str=INSERT$(s$,".",s$.Length-one)
  ELSE
    RK2str=s$  'STR$(xInt)
  END IF
ELSE
  MEMSET(VARPTR(xIEEE),0,8)
  xInt=RK AND xRKEncoded
  MEMCPY(VARPTR(xIEEE)+4,VARPTR(xInt),4)
  IF RK AND xRKby100 THEN RK2str=STR$(xIEEE/100.0) ELSE RK2str=STR$(xIEEE)
END IF
END FUNCTION

FUNCTION StrRecLen 'returns bytes from ptr to next record
DIM kk As LONG 
sLength=M.ReadNum(2): kk=sLength
sCode=0: sCode=M.ReadNum(1)
IF sCode AND 1 THEN sLength=2*sLength: kk=sLength 'String not compressed
IF sCode AND 8 THEN kk=M.ReadNum(2): kk=sLength+4*kk 'RichString
IF sCode AND 4 THEN i=M.ReadNum(4): kk=kk+i  'Far East
StrRecLen=kk
END FUNCTION

FUNCTION B2W(index As LONG) AS WORD
B2W=buf(index)+256*buf(index+1)
END FUNCTION

SUB ClearBookData
nSheets=0: nSR=0 : tSST=0: nSST=0 
INITARRAY SST 
INITARRAY SheetName
INITARRAY P
END SUB

'This uses OLE FAT to read file.  The code is not yet optimized.
SUB ReadOLEFile
DIM FATlen As LONG, DIRptr As LONG, FATindex As LONG, FATptr As LONG
DIM BB As LONG, NextFAT As LONG, ptrFATindex As LONG, EndFATindex As LONG
DIM WBptr As LONG, FATseg As LONG
F.Open(FileSpec,0)
F.Position=&H1E: i=F.ReadNum(2): BB=2^i  'size of big block sectors
F.Position=&H2C: FATlen=F.ReadNum(4)
F.Position=&H30: i=F.ReadNum(4): DIRptr=i*BB+BB
F.Position=&H44: FATindex=F.ReadNum(4): INC(FATindex)
'IF FATindex THEN FATindex=FATindex*BB+BB 'FAT index exceeds OLE header
M.Position=0: ptrFATindex=&H4C: EndFATindex=BB 

'Find Workbook entry
WBptr=DIRptr
F.Position=DIRptr+&H74: xInt=F.ReadNum(4) 'may be offset into FAT
IF xInt<0 OR xInt>32 THEN xInt=0    'but only if it is positive and not too big
FOR j=1 to 3: WBptr=WBptr+&H80
F.Position=WBptr: i=F.ReadNum(4)
IF i=&H6F0057 THEN Goto FoundWBptr
NEXT j
sERR="Workbook OLE directory entry not found": Exit Sub
FoundWBptr:
F.Position=WBptr+&H74: j=F.ReadNum(4)
IF j<=0 THEN j=xInt   'use the right offset into FAT
P(0,1)=F.ReadNum(4) 'BIFF8 size

FOR k=1 to FATlen  'do a FAT sector
'next we switch to FAT index extension, if applicable
IF ptrFATindex>=EndFATindex THEN
  ptrFATindex=FATindex*BB  'end of OLE header or FAT index sector
  EndFATindex=ptrFATindex+BB
  F.Position=EndFATindex-4: FATindex=F.ReadNum(4): INC(FATindex)
END IF  

F.Position=ptrFATindex: i=F.ReadNum(4): ptrFATindex=ptrFATindex+4
IF i<0 THEN sERR="Bad FAT index": Exit Sub
FATptr=i*BB+BB: xNext=FATptr+BB: FATseg=FATptr
IF k=1 THEN FATptr=FATseg+j*4 'offset into FAT

IF ptrFATindex=EndFATindex THEN NextFAT=FATindex ELSE NextFAT=F.ReadNum(4): INC(NextFAT)
j=0 

GetFATPointer:
IF FATptr>=xNext THEN Goto NextFATSector
F.Position=FATptr: i=F.ReadNum(4): FATptr=FATptr+4
IF j=0 THEN j=i-1

IF i=NextFAT THEN i=j+1: Goto LoadSector
SELECT CASE i
CASE &HFFFFFFFF: j=0: Goto GetFATPointer
CASE &HFFFFFFFE  '-2 is EOF marker, but you read one more sector of user data
  IF M.Size<2048 THEN  'this because short OLE-generated files have bad DIRptr
    i=F.ReadNum(4): j=i-1: Goto LoadSector
  END IF
CASE &HFFFFFFFD: j=0: Goto GetFATPointer 'inserted garbage; skip it
CASE &HFFFFFFFC: j=0: Goto GetFATPointer
END SELECT

LoadSector:
INC(j): F.Position=j*&H200: M.CopyFrom(F,&H200)
IF i=-2 THEN Goto LoadDone 'EOF
IF i<>j THEN i=(i*4) MOD BB: FATptr=FATseg+i: j=0
Goto GetFATPointer

NextFATSector:
NEXT k

LoadDone:
P(0,2)=M.Size: F.Close
IF P(0,2)<P(0,1) THEN sERR="All BIFF8 data not loaded"
END SUB

SUB FillFile(fvalue As LONG, amt As LONG)
IF fvalue THEN blen = 4 ELSE blen = 1
FillFileDone:
i=(F.Position-&H200) MOD amt
IF i THEN F.WriteNum(fvalue,blen): Goto FillFileDone
END SUB

SUB SheetPointers(s As LONG, nbytes As LONG)
i=s+1: j=nbytes
CheckSheetNumber:
IF i>nSR THEN Exit Sub
ChangeValue(P(i,pSHEET)+4,4,j)
M.Position=P(i,pOFFSET)+20
GetRecord
k=P(i,pOFFSET)+36
UpdateINDEX2:
ChangeValue(k,4,j): INC(k,4)
IF k<xNext THEN Goto UpdateINDEX2
P(i,pOFFSET)=P(i,pOFFSET)+j: P(i,pDIMENSIONS)=P(i,pDIMENSIONS)+j 
INC(i): Goto CheckSheetNumber
END SUB

SUB ChangeValue(ptr As LONG, blen As LONG, nbytes As LONG)
M.Position=ptr: xTmp=M.ReadNum(blen)
xTmp=xTmp+nbytes
M.Position=ptr: M.WriteNum(xTmp,blen) 
END SUB

SUB ShiftBook(ptr As LONG, nbytes As LONG)
DIM mfrom As LONG, t$ As STRING, mPos As LONG
'print "nbytes="; nbytes
mPos=M.Position
SELECT CASE nbytes
CASE <0
  mfrom=ptr-nbytes: i=one+M.Size-mfrom
  M.Position=mfrom: t$=M.ReadStr(i)
  M.Position=ptr: M.WriteStr(t$,i): t$.close
  M.Size=M.Size+nbytes
CASE >0
  i=M.Size-ptr
  M.Position=ptr: t$=M.ReadStr(i)
  M.Position=ptr+nbytes: M.WriteStr(t$,i): t$.close
END SELECT
M.Position=mPos
END SUB

'Utility routines to display internal data
SUB PrintSheetNames   'For CONSOLE application
For i=0 to nSheets: Print SheetName(i)
For j=0 to NumVars: PRINT space;RIGHT$(HEX$(P(i,j)),7);: NEXT j
PRINT: NEXT i
END SUB

SUB PrintSSTRecords
PRINT "No. SST blocks=";STR$(nSST+1);" Strings in SST=";STR$(tSST)
For j=0 to nSST: PRINT STR$(SST(j,1));space;: Next j
PRINT
END SUB
